#ifndef _DEF_LEVEL
#define _DEF_LEVEL

#include <gint/defs/types.h>

#include "tiles.h"

typedef struct Level {
	uint width;  /* in tiles */
	uint height; /* in tiles */
	const Tile **layers; /* points toward the level content */
	uint8_t layers_count;
	uint8_t solid_layer; /* id of the solid layer */
} Level;

#include "camera.h"

void level_step(const Level *level);
void level_draw(const Level *level, Camera *camera);
void layer_draw(const Level *level, Camera *camera, uint layer_id);

#endif /* _DEF_LEVEL */
